;--------------------------------------------------------
; File Created by SDCC : free open source ANSI-C Compiler
; Version 4.0.0 #11528 (Linux)
;--------------------------------------------------------
	.module hello_world
	.optsdcc -mz80
	
;--------------------------------------------------------
; Public variables in this module
;--------------------------------------------------------
	.globl _main
	.globl _readC8255
	.globl _writeA8255
	.globl _senddisp56
	.globl _zera_disp
	.globl _wait500ms
;--------------------------------------------------------
; special function registers
;--------------------------------------------------------
;--------------------------------------------------------
; ram data
;--------------------------------------------------------
	.area _DATA
;--------------------------------------------------------
; ram data
;--------------------------------------------------------
	.area _INITIALIZED
;--------------------------------------------------------
; absolute external ram data
;--------------------------------------------------------
	.area _DABS (ABS)
;--------------------------------------------------------
; global & static initialisations
;--------------------------------------------------------
	.area _HOME
	.area _GSINIT
	.area _GSFINAL
	.area _GSINIT
;--------------------------------------------------------
; Home
;--------------------------------------------------------
	.area _HOME
	.area _HOME
;--------------------------------------------------------
; code
;--------------------------------------------------------
	.area _CODE
;hello_world.c:68: int main(void){
;	---------------------------------
; Function main
; ---------------------------------
_main::
;hello_world.c:71: byte aux1 = 0;
	ld	c, #0x00
;hello_world.c:73: zera_disp();						// inicia zerando o display
	push	bc
	call	_zera_disp
	pop	bc
;hello_world.c:75: while(TRUE){						// faz eternamente
00102$:
;hello_world.c:76: aux = readC8255();				// lê o port C
	push	bc
	call	_readC8255
	ld	a, l
	push	af
	inc	sp
	call	_senddisp56
	inc	sp
	pop	bc
;hello_world.c:78: writeA8255(aux1);				// envia 1 para o port A
	push	bc
	ld	a, c
	push	af
	inc	sp
	call	_writeA8255
	inc	sp
	call	_wait500ms
	pop	bc
;hello_world.c:81: aux1 ^= 0x01;
	ld	b, #0x00
	ld	a, c
	xor	a, #0x01
	ld	c, a
;hello_world.c:84: }
	jr	00102$
;hello_world.c:96: byte readC8255(void) __naked {
;	---------------------------------
; Function readC8255
; ---------------------------------
_readC8255::
;hello_world.c:107: __endasm;
	call	#0x8B ; lê port C do 8255
	ld	hl,#0x87CE ; pega endereço da var
	ld	a,(hl) ; em a o conteúdo
	ld	l,a ; resposta quando unsigned char sempre em l
	ret
;hello_world.c:109: }
;hello_world.c:117: void writeA8255(byte myA) __naked {
;	---------------------------------
; Function writeA8255
; ---------------------------------
_writeA8255::
;hello_world.c:129: __endasm;
	ld	iy,#2 ; inicia leitura do parâmetro
	add	iy,sp
	ld	a,(iy) ; pega valor e coloca em A
	call	#0x88 ; escreve valor no portA
	ret
;hello_world.c:131: }
;hello_world.c:139: void senddisp56(char myA) __naked {
;	---------------------------------
; Function senddisp56
; ---------------------------------
_senddisp56::
;hello_world.c:151: __endasm;
	ld	iy,#2 ; inicia leitura do parâmetro
	add	iy,sp
	ld	a,(iy) ; pega valor e coloca em A
	call	#0x7F ; envia A para o display
	ret
;hello_world.c:153: }
;hello_world.c:161: void zera_disp(void) __naked {
;	---------------------------------
; Function zera_disp
; ---------------------------------
_zera_disp::
;hello_world.c:168: __endasm;
	call	#0x7C ;zera todos displays de 7 segmentos
	ret
;hello_world.c:170: }
;hello_world.c:178: void wait500ms(void) __naked {
;	---------------------------------
; Function wait500ms
; ---------------------------------
_wait500ms::
;hello_world.c:185: __endasm;
	call	#0xA9
	ret
;hello_world.c:187: }
	.area _CODE
	.area _INITIALIZER
	.area _CABS (ABS)
